ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.12 by root, Mon Mar 12 17:26:41 2007 UTC vs.
Revision 1.50 by root, Thu Aug 9 22:54:28 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
18use IO::AIO (); 19use IO::AIO ();
20use Crossfire; 21use Crossfire;
21use Coro; 22use Coro;
22use Coro::AIO; 23use Coro::AIO;
23use POSIX (); 24use POSIX ();
24use Digest::MD5; 25use Digest::MD5;
26use Carp;
27use Coro::Storable; $Storable::canonical = 1;
28
29$SIG{QUIT} = sub { Carp::cluck "QUIT" };
25 30
26sub usage { 31sub usage {
27 warn <<EOF; 32 warn <<EOF;
28Usage: cfutil [-v] [-q] [--force] [--cache] 33Usage: cfutil [-v] [-q] [--force] [--cache]
29 [--install-arch path] 34 [--install-arch path]
41my $CACHE = 0; 46my $CACHE = 0;
42my $FORCE; 47my $FORCE;
43my $TMPDIR = "/tmp/cfutil$$~"; 48my $TMPDIR = "/tmp/cfutil$$~";
44my $TMPFILE = "aaaa0"; 49my $TMPFILE = "aaaa0";
45 50
51our %COLOR = (
52 black => 0,
53 white => 1,
54 navy => 2,
55 red => 3,
56 orange => 4,
57 blue => 5,
58 darkorange => 6,
59 green => 7,
60 lightgreen => 8,
61 grey => 9,
62 brown => 10,
63 gold => 11,
64 tan => 12,
65);
66
46END { system "rm", "-rf", $TMPDIR } 67END { system "rm", "-rf", $TMPDIR }
47 68
48Event->signal (signal => "INT", cb => sub { exit 1 }); 69Event->signal (signal => "INT", cb => sub { exit 1 });
49Event->signal (signal => "TERM", cb => sub { exit 1 }); 70Event->signal (signal => "TERM", cb => sub { exit 1 });
50 71
67} 88}
68 89
69sub inst_maps($) { 90sub inst_maps($) {
70 my (undef, $path) = @_; 91 my (undef, $path) = @_;
71 92
72 print "installing '$path' to '$DATADIR/maps'\n\n"; 93 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
73 94
74 if (!-f "$path/regions") { 95 if (!-f "$path/regions") {
75 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 96 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
76 exit 1 unless $FORCE; 97 exit 1 unless $FORCE;
77 } 98 }
78 99
79 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 100 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
101 and die "map installation failed.\n";
102
103 print "maps installed successfully.\n";
80} 104}
81 105
82{ 106{
83 our %PNG32; 107 our %ANIMINFO;
84 our %FACEINFO; 108 our %FACEINFO;
109 our %RESOURCE;
85 our @ARC; 110 our @ARC;
111 our %ARC;
86 our $TRS; 112 our $TRS;
87 our $NFILE; 113 our $NFILE;
88 our %ANIM;
89 our $SMOOTH; 114 our $PATH;
90 115
116 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
117
91 our (@png, @trs, @arc); # files we are interested in 118 our (@png, @trs, @arc, @res); # files we are interested in
92 119
93 sub commit_png { 120 sub commit_png($$$) {
94 my ($name, $data) = @_; 121 my ($name, $data, $T) = @_;
95 122
96 $PNG32{$name} = $data; 123 $FACEINFO{$name}{"data$T"} = $data;
97 $FACEINFO{$name} ||= {};
98 } 124 }
99 125
100 sub process_png { 126 sub process_png {
101 while (@png) { 127 while (@png) {
102 my $path = pop @png; 128 my ($path, $delete) = @{pop @png};
103 129
104 my $png; 130 my $png;
105 aio_lstat $path; 131 aio_lstat $path;
106 my ($size, $mtime) = (stat _)[7,9]; 132 my ($size, $mtime) = (stat _)[7,9];
107 133
108 if (0 > aio_load $path, $png) { 134 if (0 > aio_load $path, $png) {
109 warn "$path: $!, skipping.\n"; 135 warn "$path: $!, skipping.\n";
110 next; 136 next;
111 } 137 }
112 138
139 my $stem = $path;
140 my $T;
141
142 if ($stem =~ s/\.32x32\.png~?$//) {
143 $T = 32;
144 } elsif ($stem =~ s/\.64x64\.png~?$//) {
145 $T = 64;
146 } else {
147 warn "$path: weird filename, skipping.\n";
148 next;
149 }
150
113 # quickly extract width and height of the (necessarily PNG) image 151 # quickly extract width and height of the (necessarily PNG) image
114 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 152 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
115 warn "$path: not a recongized png file, skipping.\n"; 153 warn "$path: not a recognized png file, skipping.\n";
116 next; 154 next;
117 } 155 }
118 156
119 my ($w, $h) = unpack "NN", $1; 157 my ($w, $h) = unpack "NN", $1;
120
121 (my $face = $path) =~ s/^.*\///;
122 my $T = 32;
123
124 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
125 warn "$path: weird filename, skipping.\n";
126 next;
127 }
128 158
129 if ($w < $T || $h < $T) { 159 if ($w < $T || $h < $T) {
130 warn "$path: too small ($w $h), skipping.\n"; 160 warn "$path: too small ($w $h), skipping.\n";
131 next; 161 next;
132 } 162 }
134 if ($w % $T || $h % $T) { 164 if ($w % $T || $h % $T) {
135 warn "$path: weird png size ($w $h), skipping.\n"; 165 warn "$path: weird png size ($w $h), skipping.\n";
136 next; 166 next;
137 } 167 }
138 168
169 unless ($path =~ /~$/) {
170 # possibly enlarge
171 if (0 > aio_stat "$stem.64x64.png") {
172 my $other = "$stem.64x64.png~";
173
174 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
175 my $wrap = 0; # for the time being
176 fork_sub {
177 system "convert png:\Q$path\E -depth 8 rgba:-"
178 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap"
179 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~"
180 and die "convert/hq2xa pipeline error: status $? ($!)";
181 system $OPTIPNG, "-i0", "-q", "$other~";
182 die "$other~ has zero size, aborting." unless -s "$other~";
183 rename "$other~", $other;
184 };
185 }
186
187 push @png, [$other, !$CACHE];
188 }
189
190 # possibly scale down
191 if (0 > aio_stat "$stem.32x32.png") {
192 my $other = "$stem.32x32.png~";
193
194 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
195 fork_sub {
196 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
197 system $OPTIPNG, "-i0", "-q", "$other~";
198
199 # reduce smoothfaces >10000 bytes
200 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
201 my $ncolor = 256;
202 while () {
203 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
204 system $OPTIPNG, "-i0", "-q", "$other~~";
205 last if 10000 > -s "$other~~";
206 $ncolor = int $ncolor * 0.9;
207 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
208 }
209
210 printf "reduced %s from %d to %d bytes using %d colours.\n",
211 $other, -s "$other~", -s "$other~~", $ncolor
212 if $VERBOSE >= 2;
213 rename "$other~~", "$other~";
214 }
215
216 die "$other~ has zero size, aborting." unless -s "$other~";
217 rename "$other~", $other;
218 };
219 }
220
221 #warn "scaled down $path to $other\n";#d#
222 push @png, [$other, !$CACHE];
223 }
224 }
225
226 (my $face = $stem) =~ s/^.*\///;
227
228 # split all bigfaces, but avoid smoothfaces (*_S)
139 if (($w > $T || $h > $T) && $face !~ /_S\./) { 229 if (($w > $T || $h > $T) && $face !~ /_S\./) {
140 # split 230 # split
141 my @tile; 231 my @tile;
142 for my $x (0 .. (int $w / $T) - 1) { 232 for my $x (0 .. (int $w / $T) - 1) {
143 for my $y (0 .. (int $h / $T) - 1) { 233 for my $y (0 .. (int $h / $T) - 1) {
157 ( 247 (
158 "(", 248 "(",
159 "+clone", 249 "+clone",
160 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 250 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
161 "+repage", 251 "+repage",
252 -quality => "00",
162 -write => "png:$_->[2]~", 253 -write => "png32:$_->[2]~",
163 "+delete", 254 "+delete",
164 ")", 255 ")",
165 ) 256 )
166 } @todo), 257 } @todo),
167 "null:"; 258 "null:";
171 close $convert; 262 close $convert;
172 263
173 # pass 2, optimise, and rename 264 # pass 2, optimise, and rename
174 for (@todo) { 265 for (@todo) {
175 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 266 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
267 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
176 rename "$_->[2]~", $_->[2]; 268 rename "$_->[2]~", $_->[2];
177 } 269 }
178 }; 270 };
179 } 271 }
180 272
184 276
185 if (0 > aio_load $file, $tile) { 277 if (0 > aio_load $file, $tile) {
186 die "$path: unable to read tile +$x+$y, aborting.\n"; 278 die "$path: unable to read tile +$x+$y, aborting.\n";
187 } 279 }
188 IO::AIO::aio_unlink $file unless $CACHE; 280 IO::AIO::aio_unlink $file unless $CACHE;
189 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 281 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
190 } 282 }
191 } else { 283 } else {
192 # use as-is (either small, use smooth) 284 # use as-is (either small, use smooth)
193 commit_png $face, $png; 285 commit_png $face, $png, $T;
194 } 286 }
287
288 aio_unlink $path if $delete;
195 } 289 }
196 } 290 }
197 291
198 sub process_arc { 292 sub process_arc {
199 while (@arc) { 293 while (@arc) {
203 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 297 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
204 298
205 my $arc = read_arch "$dir/$file"; 299 my $arc = read_arch "$dir/$file";
206 for my $o (values %$arc) { 300 for my $o (values %$arc) {
207 push @ARC, $o; 301 push @ARC, $o;
302 for (my $m = $o; $m; $m = $m->{more}) {
303 $ARC{$m->{_name}} = $m;
304 }
208 305
209 $o->{editor_folder} = $dir; 306 $o->{editor_folder} = $dir;
210 307
211 my $visibility = delete $o->{visibility}; 308 my $visibility = delete $o->{visibility};
212 my $magicmap = delete $o->{magicmap}; 309 my $magicmap = delete $o->{magicmap};
223 my $x = $o->{x} - $dx; 320 my $x = $o->{x} - $dx;
224 my $y = $o->{y} - $dy; 321 my $y = $o->{y} - $dy;
225 322
226 my $ext = $x|$y ? "+$x+$y" : ""; 323 my $ext = $x|$y ? "+$x+$y" : "";
227 324
228 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 325 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
229 326
230 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 327 $visibility = delete $o->{visibility} if exists $o->{visibility};
231 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 328 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
232 329
233 my $anim = delete $o->{anim}; 330 my $anim = delete $o->{anim};
234 331
235 if ($anim) { 332 if ($anim) {
333 # possibly add $ext to the animation name to avoid
334 # the need to specify archnames for all parts
335 # of a multipart archetype.
236 $o->{animation} = "$o->{_name}"; 336 $o->{animation} = "$o->{_name}";
337 my $facings = 1;
338 my @frames;
237 339
238 for (@$anim) { 340 for (@$anim) {
239 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 341 if (/^facings\s+(\d+)/) {
342 $facings = $1*1;
343 } elsif (/^blank.x11$|^empty.x11$/) {
344 push @frames, $_;
345 } else {
346 push @frames, "$_$ext";
347 }
240 } 348 }
241 349
242 $ANIM{"$o->{_name}$ext"} = 350 $ANIMINFO{$o->{animation}} = {
243 join "", map "$_\n", 351 facings => $facings,
244 "anim $o->{_name}", 352 frames => \@frames,
245 @$anim, 353 };
246 "mina";
247 } 354 }
248 355
249 for my $face ($o->{face} || (), @{$anim || []}) { 356 for my $face ($o->{face} || (), @{$anim || []}) {
250 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 357 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/;
251 358
254 $info->{visibility} = $visibility if defined $visibility; 361 $info->{visibility} = $visibility if defined $visibility;
255 $info->{magicmap} = $magicmap if defined $magicmap; 362 $info->{magicmap} = $magicmap if defined $magicmap;
256 } 363 }
257 364
258 if (my $smooth = delete $o->{smoothface}) { 365 if (my $smooth = delete $o->{smoothface}) {
259 $SMOOTH .= "$smooth\n"; 366 my %kv =split /\s+/, $smooth;
367 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
368 while (my ($face, $smooth) = each %kv) {
369 $FACEINFO{$face}{smooth} = $smooth;
370 $FACEINFO{$face}{smoothlevel} = $level;
371 }
260 } 372 }
261 } 373 }
262 } 374 }
263 } 375 }
264 } 376 }
276 388
277 $TRS .= $trs; 389 $TRS .= $trs;
278 } 390 }
279 } 391 }
280 392
393 my %FILECACHE;
394
395 sub load_cached($;$) {
396 unless (exists $FILECACHE{$_[0]}) {
397 my $data;
398 if (0 < aio_load $_[0], $data) {
399 if ($_[1]) {
400 $data = eval { $_[1]->($data) };
401 warn "$_[0]: $@" if $@;
402 }
403 }
404
405 $FILECACHE{$_[0]} = $data;
406 }
407
408 $FILECACHE{$_[0]}
409 }
410
411 sub process_res {
412 while (@res) {
413 my ($dir, $file, $type) = @{pop @res};
414
415 my $data;
416 aio_load "$dir/$file", $data;
417
418 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
419
420 next if $meta && !exists $meta->{$file};
421
422 $meta = {
423 %{ $meta->{"" } || {} },
424 %{ $meta->{$file} || {} },
425 };
426
427 if ($meta->{license} =~ s/^#//) {
428 $meta->{license} = ({
429 "pd" => "Public Domain",
430 "gpl" => "GNU General Public License, version 3.0 or any later",
431 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
432 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.5/",
433 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
434 })->{$meta->{license}}
435 || warn "$dir/$file: license tag '$meta->{license}' not found.";
436 }
437
438 $file =~ s/\.res$//;
439 $file =~ s/\.(ogg|wav|jpg|png)$//;
440
441 substr $dir, 0, 1 + length $PATH, "";
442
443 $RESOURCE{"$dir/$file"} = {
444 type => (delete $meta->{type}) || $type,
445 data => $data,
446 chksum => (Digest::MD5::md5 $data),
447 %$meta ? (meta => $meta) : (),
448 };
449 }
450 }
451
281 sub find_files; 452 sub find_files;
282 sub find_files { 453 sub find_files {
283 my ($path) = @_; 454 my ($path) = @_;
284 455
285 IO::AIO::aioreq_pri 4; 456 IO::AIO::aioreq_pri 4;
287 my ($dirs, $nondirs) = @_; 458 my ($dirs, $nondirs) = @_;
288 459
289 find_files "$path/$_" 460 find_files "$path/$_"
290 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 461 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
291 462
463 my $dir = $path;
464 substr $dir, 0, 1 + length $PATH, "";
465
292 for my $file (@$nondirs) { 466 for my $file (@$nondirs) {
467 if ($dir =~ /^music(?:\/|$)/) {
468 push @res, [$path, $file, 3] # FT_MUSIC
469 if $file =~ /\.(ogg)$/;
470
471 } elsif ($dir =~ /^sound(?:\/|$)/) {
472 push @res, [$path, $file, 5] # FT_SOUND
473 if $file =~ /\.(wav|ogg)$/;
474
475 } elsif ($dir =~ /^res(?:\/|$)/) {
476 push @res, [$path, $file, 0] # FT_FACE
477 if $file =~ /\.(jpg|png)$/;
478 push @res, [$path, $file, 7] # FT_RSRC
479 if $file =~ /\.(res)$/;
480
293 if ($file =~ /\.png$/) { 481 } elsif ($file =~ /\.png$/) {
294 push @png, "$path/$file"; 482 push @png, ["$path/$file", 0];
483
295 } elsif ($file =~ /\.trs$/) { 484 } elsif ($file =~ /\.trs$/) {
296 push @trs, [$path, $file]; 485 push @trs, [$path, $file];
486
297 } elsif ($file =~ /\.arc$/) { 487 } elsif ($file =~ /\.arc$/) {
298 push @arc, [$path, $file]; 488 push @arc, [$path, $file];
489
299 } else { 490 } else {
300 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 491 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
301 } 492 }
302 } 493 }
303 }; 494 };
304 } 495 }
305 496
306 sub inst_arch($) { 497 sub inst_arch($) {
307 my (undef, $path) = @_; 498 my (undef, $path) = @_;
308 499
500 $PATH = $path;
501
502 print "\n",
309 print "installing '$path' to '$DATADIR'\n\n"; 503 "Installing '$path' to '$DATADIR'\n",
504 "\n",
505 "This can take a long time if you run this\n",
506 "for the first time or do not use --cache.\n",
507 "\n",
508 "Unless you run verbosely, all following warning\n",
509 "or error messages indicate serious problems.\n",
510 "\n";
310 511
311 if (!-d "$path/treasures") { 512 if (!-d "$path/treasures") {
312 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 513 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
313 exit 1 unless $FORCE; 514 exit 1 unless $FORCE;
314 } 515 }
315 516
316 find_files $path; 517 find_files $path;
317 IO::AIO::flush; 518 IO::AIO::flush;
318 519
319 $_->join for ( 520 $_->join for (
320 (async \&process_png), (async \&process_png), 521 # four png crunchers work fine for my 2x smp machine
522 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png),
321 (async \&process_trs), (async \&process_trs), 523 (async \&process_trs), (async \&process_trs),
322 (async \&process_arc), (async \&process_arc), 524 (async \&process_arc), (async \&process_arc),
525 (async \&process_res), (async \&process_res),
323 ); 526 );
324 527
325 { 528 {
326 open my $fh, ">:utf8", "$DATADIR/animations~" 529 # remove path prefix from editor_folder
327 or die "$DATADIR/animations~: $!"; 530 substr $_->{editor_folder}, 0, 1 + length $path, ""
328 print $fh join "", map $ANIM{$_}, sort keys %ANIM 531 for values %ARC;
532
533 # resolve inherit
534 while () {
535 my $progress;
536 my $loop;
537
538 for my $o (values %ARC) {
539 if (my $other = $o->{inherit}) {
540 if (my $s = $ARC{$other}) {
541 if ($s->{inherit}) {
542 $loop = $s;
543 } else {
544 delete $o->{inherit};
545 my %s = %$s;
546 delete @s{qw(_name more name name_pl)};
547 %$o = ( %s, %$o );
548 ++$progress;
549 }
550 } else {
551 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
552 delete $ARC{$o->{_name}};
553 }
554 }
555 }
556
557 unless ($progress) {
558 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
559 if $loop;
560
561 last;
562 }
329 } 563 }
330 564
331 { 565 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
566 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
567
332 open my $fh, ">:utf8", "$DATADIR/archetypes~" 568 open my $fh, ">:utf8", "$DATADIR/archetypes~"
333 or die "$DATADIR/archetypes~: $!"; 569 or die "$DATADIR/archetypes~: $!";
334 substr $_->{editor_folder}, 0, 1 + length $path, "" for @ARC; 570 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
335 print $fh Crossfire::archlist_to_string \@ARC;
336 }
337
338 {
339 open my $fh, ">:utf8", "$DATADIR/smooth~"
340 or die "$DATADIR/smooth~: $!";
341 print $fh $SMOOTH;
342 } 571 }
343 572
344 { 573 {
345 open my $fh, ">:utf8", "$DATADIR/treasures~" 574 open my $fh, ">:utf8", "$DATADIR/treasures~"
346 or die "$DATADIR/treasures~: $!"; 575 or die "$DATADIR/treasures~: $!";
347 print $fh $TRS; 576 print $fh $TRS;
348 } 577 }
349 578
350 { 579 {
351 while (my ($k, $v) = each %FACEINFO) { 580 while (my ($k, $v) = each %FACEINFO) {
352 $v->{data32} ||= delete $PNG32{$k};
353 }
354
355 while (my ($k, $v) = each %FACEINFO) {
356 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n"; 581 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
582 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
583
584 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
585 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
357 586
358 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 587 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
588 $v->{chksum64} = Digest::MD5::md5 $v->{data64};
589
590 if (my $magicmap = $v->{magicmap}) {
591 $magicmap =~ y/A-Z_\-/a-z/d;
592 $v->{magicmap} = $COLOR{$magicmap};
359 } 593 }
594 }
360 595
361 open my $fh, ">:perlio", "$DATADIR/faces~" 596 open my $fh, ">:perlio", "$DATADIR/facedata~"
362 or die "$DATADIR/faces~: $!"; 597 or die "$DATADIR/facedata~: $!";
363 598
364 print $fh Storable::nfreeze \%FACEINFO; 599 print $fh freeze {
600 version => 2,
601 faceinfo => \%FACEINFO,
602 animinfo => \%ANIMINFO,
603 resource => \%RESOURCE,
365 } 604 };
605 }
366 606
367 for (qw(archetypes faces animations treasures smooth)) { 607 for (qw(archetypes facedata treasures)) {
368 chmod 0644, "$DATADIR/$_~"; 608 chmod 0644, "$DATADIR/$_~";
369 rename "$DATADIR/$_~", "$DATADIR/$_"; 609 rename "$DATADIR/$_~", "$DATADIR/$_"
610 or die "$DATADIR/$_: $!";
370 } 611 }
612
613 print "archetype data installed successfully.\n";
371 } 614 }
372} 615}
373 616
374Getopt::Long::Configure ("bundling", "no_ignore_case"); 617Getopt::Long::Configure ("bundling", "no_ignore_case");
375GetOptions ( 618GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines